
// Update file size in .shp file header
// Assumes less than 4GB in size

#include <stdio.h>
#include <io.h>
#include <fcntl.h>

unsigned long endswap(unsigned long n);

void main(int argc, char *argv[])
{
   int fh;
   unsigned long fsize, B[1];

   if (argc != 2)
   {
      printf ("Usage:  SHPTOUCH [shp_name] \n");
      return;
   }
   // open file

   fh = _open(argv[1], _O_BINARY | _O_RDWR);
   if (fh == -1)
   {
      printf ("Could not open file.\n");
      return;
   }

   // get file size

   fsize = _filelength(fh) / 2;
   B[0] = endswap(fsize);

   // update file size

   if (_lseek(fh,24,0) == -1)
   {
      printf ("Error setting file pointer position.\n");
      _close(fh);
      return;
   }
   if (_write(fh,B,sizeof(unsigned long)) == -1)
   {
      printf ("Error writing value.\n");
   }
   _close(fh);
   return;
}

unsigned long endswap(unsigned long n)
{
   union
   {
      unsigned long p;
      unsigned char b[4];
   };
   unsigned char temp;
   int i;

   // Convert little-endian unsigned long to big-endian

   p = n;
   for (i = 0; i < 2; i++)
   {
      temp = b[i];
      b[i] = b[3-i];
      b[3-i] = temp;
   }

   return p;
}

